/*************************************************************************

                          st0rm SGE Source Code

                          (c)1998 David Sanchez
                           st0rm@melodysoft.com

                        Released on 17th March 1999
        

Este codigo fuente lo puedes utilizar para:

- Usarlo como fuente de informacin para tus proyectos.
- Continuar el proyecto st0rm.
- Empezar un emulador desde 0 teniendo este como base.

Lo nico que pido si te es util y lo usas, es que lo menciones en tu
proyecto.

Tendras que perdonarme la falta de comentarios y el desorden total,
aun asi puede ser util.


COMENTARIOS EN README.TXT

*************************************************************************/


// Programa independiente para meter graficos en el codigo

#include <dos.h>
#include <stdio.h>


void main (int argc, char *argv[]) {

  FILE         *in, *out;
  int           cnt             = 0;

  printf ("\nMelody File Dumper v0.1\n");

  if (argc < 3) {
        printf ("\nUsage: %s <in-file> <out-file>\n", argv[0]);
        exit (0);
  }

  if ((in = fopen (argv[1], "rb")) == NULL) {
        printf ("\nUnable to open %s\n", argv[1]);
        exit (0);
  }

  if ((out = fopen (argv[2], "w")) == NULL) {
        printf ("\nError opening %s\n", argv[2]);
        exit (0);
  }

  while (!feof (in)) {
        fprintf (out, "0x%02X, ", fgetc (in));
        if (cnt++ == 10) {
                fprintf (out, "\n");
                cnt = 0;
        }
  }

  fclose (in);
  fclose (out);
}
