/*************************************************************************

                          st0rm SGE Source Code

                          (c)1998 David Sanchez
                           st0rm@melodysoft.com

                        Released on 17th March 1999
        

Este codigo fuente lo puedes utilizar para:

- Usarlo como fuente de informacin para tus proyectos.
- Continuar el proyecto st0rm.
- Empezar un emulador desde 0 teniendo este como base.

Lo nico que pido si te es util y lo usas, es que lo menciones en tu
proyecto.

Tendras que perdonarme la falta de comentarios y el desorden total,
aun asi puede ser util.


COMENTARIOS EN README.TXT

*************************************************************************/


#include <dos.h>
#include <i86.h>
#include <stdio.h>
#include <malloc.h>
#include <conio.h>
#include <time.h>
#include <mem.h>
#include "vga.h"
#include "misc.h"
#include "header.h"
#include "st0rm.h"
#include "memory.h"
#include "m68k.h"
#include "m68misc.h"
#include "vdp.h"
#include "genio.h"
#include "sound.h"
#include "gensnd.h"


extern char            *sizes[];


struct _gen_snd_        gen_snd;


void FMWrite (u_long addr, u_long size, u_long to_write) {

  static u_long         snd_idx = 0;

  if (addr == 0x4000 || addr == 0x4002) {

        gen_snd.reg_req = to_write;
        return;
  }      

  if (addr == 0x4001 || addr == 0x4003) {

        switch (gen_snd.reg_req) {

          case 0x22 :
                PrintELog ("[FM] LFO = %x, rate = %d", to_write&4, to_write&3);
                return;

          case 0x2a :
                snd.wave[snd_idx++] = (u_char)to_write;
                snd.wave[snd_idx++] = (u_char)to_write;
                /*snd.wave[snd_idx++] = (u_char)to_write;
                snd.wave[snd_idx++] = (u_char)to_write;
                snd.wave[snd_idx++] = (u_char)to_write;*/
                snd.wave[snd_idx] = (u_char)to_write;
                if (snd_idx++ >= (SND_BUFSIZE*SND_NBUFS)) snd_idx = 0;
                return;

          case 0x2b :
                gen_snd.dac_enable = (to_write>>7) & 1;
                PrintELog ("[FM] dac_enable = %d", gen_snd.dac_enable);
                return;

          case 0xb4 :
                PrintELog ("[FM] AMS=%d x FMS=%d", (to_write>>4)&3, to_write&3);
                return;

          default :
                PrintELog ("[FM] Setting register %x to %lx", gen_snd.reg_req,
                           to_write);
                return;
        }
  }
}

u_long FMRead (u_long addr, u_long size) {

  //PrintELog ("[FM] Read from FM Chip at addr %s %lx", sizes[size], addr);

  return 0;
}

void PSGWrite (u_char data) {

  //PrintELog ("[PSG] Write to PSG: %x", data);
}

u_char PSGRead (void) {

  //PrintELog ("[PSG] Read from PSG");

  return 0;
}

u_long Z80Read (u_long addr, u_long size) {

  PrintELog ("[Z80] Read from %s %lx", sizes[size], addr);

  return 0;
}

void Z80Write (u_long addr, u_long size, u_long to_write) {

  PrintELog ("[Z80] Write to %s %lx: %lx", sizes[size], addr, to_write);
}
