/*************************************************************************

                          st0rm SGE Source Code

                          (c)1998 David Sanchez
                           st0rm@melodysoft.com

                        Released on 17th March 1999
        

Este codigo fuente lo puedes utilizar para:

- Usarlo como fuente de informacin para tus proyectos.
- Continuar el proyecto st0rm.
- Empezar un emulador desde 0 teniendo este como base.

Lo nico que pido si te es util y lo usas, es que lo menciones en tu
proyecto.

Tendras que perdonarme la falta de comentarios y el desorden total,
aun asi puede ser util.


COMENTARIOS EN README.TXT

*************************************************************************/


#ifndef __HEADER_INCLUDED__
#define __HEADER_INCLUDED__


typedef struct {

  unsigned long         stack_pointer;
  unsigned long         program_counter;
  char                  dummy1[0x68];
  unsigned long         horz_intr;
  unsigned long         ext_intr;
  unsigned long         vert_intr;
  char                  dummy2[0x84];
  char                  id_sega[0x10];
  char                  id2_sega[0x10];
  char                  name_dom[0x30];
  char                  name_over[0x30];
  char                  version[0x0e];
  unsigned short        checksum;
  char                  io_data[0x10];
  unsigned long         rom_start_addr;
  unsigned long         rom_end_addr;
  unsigned long         ram_start_addr;
  unsigned long         ram_end_addr;
  char                  ext_ram_data[0x0c];
  char                  modem_data[0x0c];
  char                  memo[0x28];
  char                  country[3];
  char                  dummy3[0x0d];

} RomHeader;


#endif

