/*************************************************************************

                          st0rm SGE Source Code

                          (c)1998 David Sanchez
                           st0rm@melodysoft.com

                        Released on 17th March 1999
        

Este codigo fuente lo puedes utilizar para:

- Usarlo como fuente de informacin para tus proyectos.
- Continuar el proyecto st0rm.
- Empezar un emulador desde 0 teniendo este como base.

Lo nico que pido si te es util y lo usas, es que lo menciones en tu
proyecto.

Tendras que perdonarme la falta de comentarios y el desorden total,
aun asi puede ser util.


COMENTARIOS EN README.TXT

*************************************************************************/

#ifndef __M68DEB_INCLUDED__
#define __M68DEB_INCLUDED__

#include "st0rm.h"


typedef struct _oper_ {

        unsigned short          op_code;
        unsigned short          op_mask;
        char                   *op_name;
        char                  (*op_func)();
        unsigned short          op_called;
        char                    debug;

} OperDef;



char *GiveCodeName (void);
char *GiveOpCodeName (u_short cmp);

long GivePtrAddr (u_short e_addr, u_short size, OperDef *oper);
void PutPtrAddr (u_short e_addr, u_short size, long operand, OperDef *oper);
long GiveNmAddr (u_short e_addr, u_short size, OperDef *oper);

char GiveCondCode (u_short cond);
void SetNmFlags (long operand, u_short size);
void SetCvFlags (long dest, long src, long res, u_short size);
void SetCvaFlags (long dest, long src, long res, u_short size);


#endif
