;*************************************************************************
;
;                          st0rm SGE Source Code
;
;                          (c)1998 David Sanchez
;                           st0rm@melodysoft.com
;
;                        Released on 17th March 1999
;        
;
;       Este codigo fuente lo puedes utilizar para:
;
;       - Usarlo como fuente de informacin para tus proyectos.
;       - Continuar el proyecto st0rm.
;       - Empezar un emulador desde 0 teniendo este como base.
;
;       Lo nico que pido si te es util y lo usas, es que lo menciones en tu
;       proyecto.
;
;       Tendras que perdonarme la falta de comentarios y el desorden total,
;       aun asi puede ser util.
;
;
;       COMENTARIOS EN README.TXT
;
;*************************************************************************


.486P
.MODEL FLAT


_TEXT SEGMENT DWORD PUBLIC 'CODE'
	ASSUME	cs:_TEXT, ds:_DATA


EXTRN   v_buffer:DWORD
EXTRN   vram:DWORD
EXTRN   vdp_cell_mode:BYTE


public  DoCELLH


DoCELLH         PROC

        LOCAL   n_scrl:DWORD, mode:DWORD, line:DWORD=AUTO_SIZE
        ARG     y:DWORD, w_scrl:DWORD, h_cell:DWORD, h_desp:DWORD, h_cells:DWORD, scrl_size_h:DWORD

        push    ebp
        mov     ebp, esp

        sub     esp, AUTO_SIZE

        pushad

        mov     edi, [v_buffer]

        fastimul eax, [y], 336
        add     edi, eax
        cmp     eax, 1
        jl      ldone
        cmp     eax, 13b00h
        jg      ldone

        mov     al, [vdp_cell_mode]
        test    al, al
        jnz     short l40cell

        add     edi, 32

l40cell:
        mov     eax, [h_cells]
        mov     esi, [w_scrl]
        add     eax, 2
        mov     [n_scrl], esi
        mov     [h_cells], eax
        sub     edi, [h_desp]
        mov     eax, [h_cell]
        sub     esi, 2
        shl     eax, 1
        xor     ecx, ecx
        add     esi, eax
        xor     eax, eax

next:
        mov     ebx, ecx
        add     ebx, [h_cell]
        cmp     ebx, [scrl_size_h]
        jle     no_flip_h
        mov     esi, [n_scrl]
        mov     [h_cell], 0

no_flip_h:
        mov     ax, word ptr[esi]
        add     esi, 2
        xchg    ah, al

ok1:
        test    ax, 7ffh
        jz      no_print

        ;call    PutLineEdi

        push    esi
        push    ecx

        mov     esi, [vram]
        mov     ebx, eax
        mov     ecx, eax
        and     eax, 07ffh
        mov     edx, ebx
        shl     eax, 5
        nop
        shr     ebx, 13
        add     esi, eax
        and     ebx, 3
        shr     edx, 15
        nop
        shl     ebx, 4
        and     edx, 1
        shr     ecx, 11
        add     ebx, 16
        shl     edx, 7
        and     ecx, 3
        mov     bh, dl
        mov     [mode], ecx
        push    ecx
        mov     [line], 8

        cmp     ecx, 1
        jle     short cdraw

        add     esi, 28

cdraw:
        pop     eax

        mov     ecx, 4

        test    eax, eax
        jz      short cnext_nhi
        cmp     eax, 2
        jne     short chi_draw

cnext_nhi:
        mov     al, byte ptr[esi]
        mov     dl, byte ptr[edi]
        shr     al, 4
        jz      short cblk_nhi1

        test    bh, bh
        jnz     short cdrw_nhi1

        test    dl, 80h
        jnz     short cblk_nhi1

cdrw_nhi1:
        add     al, bl
        or      al, bh
        mov     byte ptr[edi], al

cblk_nhi1:
        inc     edi
        mov     al, byte ptr[esi]
        mov     dl, byte ptr[edi]
        and     al, 0fh
        jz      short cblk_nhi2

        and     dl, 80h
        jz      short cdrw_nhi2

        test    bh, bh
        jz      short cblk_nhi2

cdrw_nhi2:
        add     al, bl
        or      al, bh
        mov     byte ptr[edi], al

cblk_nhi2:
        inc     edi
        inc     esi
        dec     ecx
        jnz     short cnext_nhi
        dec     [line]
        jz      cdone
        mov     ecx, 4
        cmp     [mode], 1
        jle     pb_nhi
        sub     esi, 8
        add     edi, 328
        jmp     short cnext_nhi

pb_nhi:
        add     edi, 328
        jmp     short cnext_nhi

chi_draw:
        add     esi, 3
cnext_hi:
        mov     al, byte ptr[esi]
        mov     dl, byte ptr[edi]
        and     al, 0fh
        jz      short cblk_hi1

        and     dl, 80h
        jz      short cdrw_hi1

        test    bh, bh
        jz      short cblk_hi1

cdrw_hi1:
        add     al, bl
        or      al, bh
        mov     byte ptr[edi], al

cblk_hi1:
        inc     edi
        mov     al, byte ptr[esi]
        mov     dl, byte ptr[edi]
        shr     al, 4
        jz      short cblk_hi2

        and     dl, 80h
        jz      short cdrw_hi2

        test    bh, bh
        jz      short cblk_hi2

cdrw_hi2:
        add     al, bl
        or      al, bh
        mov     byte ptr[edi], al

cblk_hi2:
        inc     edi
        dec     esi
        dec     ecx
        jnz     short cnext_hi
        dec     [line]
        jz      cdone
        mov     ecx, 4
        cmp     [mode], 1
        jle     pb_hi
        sub     esi, 3
        add     edi, 328
        jmp     short chi_draw

pb_hi:
        add     esi, 5
        add     edi, 328
        jmp     short chi_draw
        
cdone:
        pop     ecx
        pop     esi

        inc     ecx
        sub     edi, 2352
        cmp     ecx, [h_cells]
        jne     next
        jmp     short ldone

no_print:
        inc     ecx
        add     edi, 8

        cmp     ecx, [h_cells]
        jne     next

ldone:
        popad

        mov     esp, ebp
        pop     ebp

        ret

DoCELLH         ENDP




_TEXT ENDS

   END
