
#ifndef __VESA20_INCLUDED__
#define __VESA20_INCLUDED__


struct _rmem_ {

      unsigned long size;
      unsigned long handle;
      unsigned long linear;
      unsigned char  *ptr;
      unsigned short *ptrs;
      unsigned long  *ptrl;
};

struct _vesa20_ {

        char id[100];
        long memory;
       short version;
       short *modeptr;
      short x,y,memsize,bytesperscanline;
       char bpp,model;
       long phyaddr,memoffset;
       long scanwidth;
   unsigned char *lfb;
   unsigned short *lfbs;
   unsigned long *lfbl;
      short mode;
       char page;
        struct _rmem_ mem;  //private
};

typedef struct
    {
       long linear;
      unsigned short segment;
       long selector;
       long size;
} memdos;

long pm_getmemdos(unsigned long rmem, memdos *a);
long pm_freememdos(memdos *a);


extern struct _vesa20_          VESA20;
extern short                    cpu_type;
extern char                     cpu_id[64];
extern char                     env_id[50];

extern short                    env_type;



void Flip(long a, long b, long c);
#pragma aux Flip=  \
 "rep movsd" \
 parm [esi][edi][ecx];

void FlipFpu(long a, long b, long c);
#pragma aux FlipFpu = \ 
".586P"\
"pushad"\
"fpu_copy:"\
"fild qword ptr [esi]"\ 
"fild qword ptr [esi+8]"\
"fxch"\
"fistp qword ptr [edi]"\ 
"fistp qword ptr [edi+8]"\
"add esi,16"\
"add edi,16"\
"dec ecx"\
"jnz fpu_copy"\
"popad"\ 
parm [esi][edi][ecx];



void MachineSetup (void);


long Vesa20Setup (void);
long Vesa20SetVideoMode (short x, short y, char bpp/*, short mode*/);
void Vesa20CloseVideoMode (void);

void Vesa20ClearMem (void);
void Vesa20ClearPage (short page);

long Vesa20SetDirectVideoMode (short x, short y, char bpp, short m);


#endif
