/*************************************************************************

                          st0rm SGE Source Code

                          (c)1998 David Sanchez
                           st0rm@melodysoft.com

                        Released on 17th March 1999
        

Este codigo fuente lo puedes utilizar para:

- Usarlo como fuente de informacin para tus proyectos.
- Continuar el proyecto st0rm.
- Empezar un emulador desde 0 teniendo este como base.

Lo nico que pido si te es util y lo usas, es que lo menciones en tu
proyecto.

Tendras que perdonarme la falta de comentarios y el desorden total,
aun asi puede ser util.


COMENTARIOS EN README.TXT

*************************************************************************/

#ifndef __ST0RM_H__
#define __ST0RM_H__

#include "memory.h"
#include "sizedefs.h"
#include "gui.h"


#define ST0RM_LOG


struct _st0rm_cfg_ {

        u_char  frame_skip;

        u_char  raster_effects;
        u_char  h_scrl;
        u_char  window;
        u_char  scrl_a;
        u_char  scrl_b;
        u_char  sprs;

        u_char  z80;
        u_char  dac;
        u_char  psg;
        u_char  fm;

        u_char  checksums;
        u_char  wait_sync;
        u_char  fpu_copy;

        u_char  version;
        char    rom_path[320];
};

extern  struct _st0rm_cfg_      st0rm_cfg;
extern  u_long                  rom_loaded;

extern  Mem                     mem;
extern  char                    log_flg;
extern  char                    loge_flg;
extern  FILE                   *log_file;

extern  GUISystem              *GUI;

extern  char                    vesa_flg;


void ExecuteN (u_long inst);
void ExitNow (void);

void DebugOp (void);


#endif

