;*************************************************************************
;
;                          st0rm SGE Source Code
;
;                          (c)1998 David Sanchez
;                           st0rm@melodysoft.com
;
;                        Released on 17th March 1999
;        
;
;       Este codigo fuente lo puedes utilizar para:
;
;       - Usarlo como fuente de informacin para tus proyectos.
;       - Continuar el proyecto st0rm.
;       - Empezar un emulador desde 0 teniendo este como base.
;
;       Lo nico que pido si te es util y lo usas, es que lo menciones en tu
;       proyecto.
;
;       Tendras que perdonarme la falta de comentarios y el desorden total,
;       aun asi puede ser util.
;
;
;       COMENTARIOS EN README.TXT
;
;*************************************************************************


.486P
.MODEL FLAT


_TEXT SEGMENT DWORD PUBLIC 'CODE'
	ASSUME	cs:_TEXT, ds:_DATA


EXTRN   v_buffer:DWORD
EXTRN   vram:DWORD
EXTRN   vdp_cell_mode:BYTE




public  PutLineAsm
public  DoCELLAsm
public  DoCELLSpr


PutLineAsm      PROC

        ARG     addr:DWORD, line:DWORD, y:DWORD, x:DWORD

        push    ebp
        mov     ebp, esp

        pushad

        mov     al, [vdp_cell_mode]
        test    al, al
        jnz     l40cell

        add     [x], 32

l40cell:
        mov     eax, [addr]
        mov     esi, [vram]
        mov     ebx, eax
        mov     ecx, eax
        and     eax, 07ffh
        mov     edi, [v_buffer]
        mov     edx, ebx
        shl     eax, 5
        shr     ebx, 13
        add     esi, eax
        and     ebx, 3
        shr     edx, 15
        shl     ebx, 4
        and     edx, 1
        shr     ecx, 11
        add     ebx, 16
        shl     edx, 7
        and     ecx, 3
        mov     bh, dl
        mov     edx, [line]
        push    ecx
        shl     edx, 2

        cmp     ecx, 1
        jle     short no_vert_inv

        add     esi, 28
        sub     esi, edx
        jmp     short draw

no_vert_inv:
        add     esi, edx

draw:
        pop     eax

        fastimul ecx, [y], 336

        cmp     ecx, 13b00h
        jg      done

        add     edi, ecx
        mov     ecx, 4
        add     edi, [x]
        
        test    eax, eax
        jz      short next_nhi
        cmp     eax, 2
        jne     short hi_draw

next_nhi:
        mov     al, byte ptr[esi]
        mov     dl, byte ptr[edi]
        shr     al, 4
        jz      short blk_nhi1

        test    bh, bh
        jnz     short drw_nhi1

        test    dl, 80h
        jnz     short blk_nhi1

drw_nhi1:
        add     al, bl
        or      al, bh
        mov     byte ptr[edi], al

blk_nhi1:
        inc     edi
        mov     al, byte ptr[esi]
        mov     dl, byte ptr[edi]
        and     al, 0fh
        jz      short blk_nhi2

        and     dl, 80h
        jz      short drw_nhi2

        test    bh, bh
        jz      short blk_nhi2

drw_nhi2:
        add     al, bl
        or      al, bh
        mov     byte ptr[edi], al

blk_nhi2:
        inc     edi
        inc     esi
        dec     ecx
        jnz     short next_nhi
        jmp     short done

hi_draw:
        add     esi, 3
next_hi:
        mov     al, byte ptr[esi]
        mov     dl, byte ptr[edi]
        and     al, 0fh
        jz      short blk_hi1

        and     dl, 80h
        jz      short drw_hi1

        test    bh, bh
        jz      short blk_hi1

drw_hi1:
        add     al, bl
        or      al, bh
        mov     byte ptr[edi], al

blk_hi1:
        inc     edi
        mov     al, byte ptr[esi]
        mov     dl, byte ptr[edi]
        shr     al, 4
        jz      short blk_hi2

        and     dl, 80h
        jz      short drw_hi2

        test    bh, bh
        jz      short blk_hi2

drw_hi2:
        add     al, bl
        or      al, bh
        mov     byte ptr[edi], al

blk_hi2:
        inc     edi
        dec     esi
        dec     ecx
        jnz     short next_hi
        
done:

        popad

        mov     esp, ebp
        pop     ebp

        ret

PutLineAsm      ENDP



DoCELLAsm       PROC

        LOCAL   mode:DWORD, line:DWORD=AUTO_SIZE
        ARG     addr:DWORD, y:DWORD, x:DWORD

        push    ebp
        mov     ebp, esp

        sub     esp, AUTO_SIZE

        pushad

        mov     al, [vdp_cell_mode]
        test    al, al
        jnz     c40cell

        add     [x], 32
c40cell:
        mov     ebx, [x]
        cmp     ebx, 328
        jg      cdone
        cmp     [y], 0
        jle     cdone
        cmp     ebx, 0
        jle     cdone

        mov     eax, [addr]
        mov     esi, [vram]
        mov     ebx, eax
        mov     ecx, eax
        and     eax, 07ffh
        mov     edi, [v_buffer]
        mov     edx, ebx
        shl     eax, 5
        shr     ebx, 13
        add     esi, eax
        and     ebx, 3
        shr     edx, 15
        shl     ebx, 4
        and     edx, 1
        shr     ecx, 11
        add     ebx, 16
        shl     edx, 7
        and     ecx, 3
        mov     bh, dl
        mov     [mode], ecx
        push    ecx
        mov     [line], 8

        cmp     ecx, 1
        jle     short cdraw

        add     esi, 28

cdraw:
        pop     eax

        fastimul ecx, [y], 336

        cmp     ecx, 13b00h
        jg      cdone

        add     edi, ecx
        mov     ecx, 4
        add     edi, [x]
        
        test    eax, eax
        jz      short cnext_nhi
        cmp     eax, 2
        jne     short chi_draw

cnext_nhi:
        mov     al, byte ptr[esi]
        mov     dl, byte ptr[edi]
        shr     al, 4
        jz      short cblk_nhi1

        test    bh, bh
        jnz     short cdrw_nhi1

        test    dl, 80h
        jnz     short cblk_nhi1

cdrw_nhi1:
        add     al, bl
        or      al, bh
        mov     byte ptr[edi], al

cblk_nhi1:
        inc     edi
        mov     al, byte ptr[esi]
        mov     dl, byte ptr[edi]
        and     al, 0fh
        jz      short cblk_nhi2

        and     dl, 80h
        jz      short cdrw_nhi2

        test    bh, bh
        jz      short cblk_nhi2

cdrw_nhi2:
        add     al, bl
        or      al, bh
        mov     byte ptr[edi], al

cblk_nhi2:
        inc     edi
        inc     esi
        dec     ecx
        jnz     short cnext_nhi
        dec     [line]
        jz      cdone
        mov     ecx, 4
        cmp     [mode], 1
        jle     pb_nhi
        sub     esi, 8
        add     edi, 328
        jmp     short cnext_nhi

pb_nhi:
        add     edi, 328
        jmp     short cnext_nhi

chi_draw:
        add     esi, 3
cnext_hi:
        mov     al, byte ptr[esi]
        mov     dl, byte ptr[edi]
        and     al, 0fh
        jz      short cblk_hi1

        and     dl, 80h
        jz      short cdrw_hi1

        test    bh, bh
        jz      short cblk_hi1

cdrw_hi1:
        add     al, bl
        or      al, bh
        mov     byte ptr[edi], al

cblk_hi1:
        inc     edi
        mov     al, byte ptr[esi]
        mov     dl, byte ptr[edi]
        shr     al, 4
        jz      short cblk_hi2

        and     dl, 80h
        jz      short cdrw_hi2

        test    bh, bh
        jz      short cblk_hi2

cdrw_hi2:
        add     al, bl
        or      al, bh
        mov     byte ptr[edi], al

cblk_hi2:
        inc     edi
        dec     esi
        dec     ecx
        jnz     short cnext_hi
        dec     [line]
        jz      cdone
        mov     ecx, 4
        cmp     [mode], 1
        jle     pb_hi
        sub     esi, 3
        add     edi, 328
        jmp     short chi_draw

pb_hi:
        add     esi, 5
        add     edi, 328
        jmp     short chi_draw
        
cdone:
        popad

        mov     esp, ebp
        pop     ebp

        ret

DoCELLAsm       ENDP



DoCELLSpr       PROC

        LOCAL   mode:DWORD, line:DWORD=AUTO_SIZE
        ARG     addr:DWORD, y:DWORD, x:DWORD

        push    ebp
        mov     ebp, esp

        sub     esp, AUTO_SIZE

        pushad

        mov     al, [vdp_cell_mode]
        test    al, al
        jnz     s40cell

        add     [x], 32
s40cell:
        mov     ebx, [x]
        cmp     ebx, 328
        jg      sdone
        cmp     [y], 0
        jle     sdone
        cmp     ebx, 0
        jle     sdone

        mov     eax, [addr]
        mov     esi, [vram]
        mov     ebx, eax
        mov     ecx, eax
        and     eax, 07ffh
        mov     edi, [v_buffer]
        mov     edx, ebx
        shl     eax, 5
        shr     ebx, 13
        add     esi, eax
        and     ebx, 3
        shr     edx, 15
        shl     ebx, 4
        and     edx, 1
        shr     ecx, 11
        add     ebx, 16
        shl     edx, 7
        and     ecx, 3
        or      edx, 40h
        mov     bh, dl
        mov     [mode], ecx
        push    ecx
        mov     [line], 8

        cmp     ecx, 1
        jle     short sdraw

        add     esi, 28

sdraw:
        pop     eax

        fastimul ecx, [y], 336

        cmp     ecx, 13b00h
        jg      sdone

        add     edi, ecx
        mov     ecx, 4
        add     edi, [x]
        
        test    eax, eax
        jz      short snext_nhi
        cmp     eax, 2
        jne     short shi_draw

snext_nhi:
        mov     dl, byte ptr[edi]
        mov     al, byte ptr[esi]

        test    dl, 40h
        jnz     short sblk_nhi1

        shr     al, 4
        jz      short sblk_nhi1

        test    bh, 80h
        jnz     short sdrw_nhi1

        test    dl, 80h
        jnz     short sblk_nhi1

sdrw_nhi1:
        add     al, bl
        or      al, bh
        mov     byte ptr[edi], al

sblk_nhi1:
        inc     edi
        mov     dl, byte ptr[edi]
        mov     al, byte ptr[esi]

        test    dl, 40h
        jnz     short sblk_nhi2

        and     al, 0fh
        jz      short sblk_nhi2

        and     dl, 80h
        jz      short sdrw_nhi2

        test    bh, 80h
        jz      short sblk_nhi2

sdrw_nhi2:
        add     al, bl
        or      al, bh
        mov     byte ptr[edi], al

sblk_nhi2:
        inc     edi
        inc     esi
        dec     ecx
        jnz     short snext_nhi
        dec     [line]
        jz      sdone
        mov     ecx, 4
        cmp     [mode], 1
        jle     spb_nhi
        sub     esi, 8
        add     edi, 328
        jmp     short snext_nhi

spb_nhi:
        add     edi, 328
        jmp     short snext_nhi

shi_draw:
        add     esi, 3
snext_hi:
        mov     dl, byte ptr[edi]
        mov     al, byte ptr[esi]

        test    dl, 40h
        jnz     short sblk_hi1

        and     al, 0fh
        jz      short sblk_hi1

        and     dl, 80h
        jz      short sdrw_hi1

        test    bh, 80h
        jz      short sblk_hi1

sdrw_hi1:
        add     al, bl
        or      al, bh
        mov     byte ptr[edi], al

sblk_hi1:
        inc     edi
        mov     dl, byte ptr[edi]
        mov     al, byte ptr[esi]

        test    dl, 40h
        jnz     short sblk_hi2

        shr     al, 4
        jz      short sblk_hi2

        and     dl, 80h
        jz      short sdrw_hi2

        test    bh, 80h
        jz      short sblk_hi2

sdrw_hi2:
        add     al, bl
        or      al, bh
        mov     byte ptr[edi], al

sblk_hi2:
        inc     edi
        dec     esi
        dec     ecx
        jnz     short snext_hi
        dec     [line]
        jz      sdone
        mov     ecx, 4
        cmp     [mode], 1
        jle     spb_hi
        sub     esi, 3
        add     edi, 328
        jmp     short shi_draw

spb_hi:
        add     esi, 5
        add     edi, 328
        jmp     short shi_draw
        
sdone:
        popad

        mov     esp, ebp
        pop     ebp

        ret

DoCELLSpr       ENDP




_TEXT ENDS

   END
